VERSION 5.00
Begin VB.Form frmSettings 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "COM-Port"
   ClientHeight    =   3360
   ClientLeft      =   975
   ClientTop       =   2970
   ClientWidth     =   2565
   Icon            =   "Settings.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3360
   ScaleWidth      =   2565
   ShowInTaskbar   =   0   'False
   Begin VB.Frame Frame3 
      Height          =   855
      Left            =   60
      TabIndex        =   10
      Top             =   2040
      Width           =   2415
      Begin VB.OptionButton optDevice 
         Caption         =   "M3&8xx (4 frames)"
         Height          =   195
         Index           =   1
         Left            =   180
         TabIndex        =   12
         Top             =   540
         Width           =   2055
      End
      Begin VB.OptionButton optDevice 
         Caption         =   "&Default DMM (one frame)"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   11
         Top             =   240
         Width           =   2115
      End
   End
   Begin VB.Frame Frame2 
      Height          =   1215
      Left            =   60
      TabIndex        =   4
      Top             =   810
      Width           =   2415
      Begin VB.OptionButton optBPS 
         Caption         =   "&9600 bps"
         Height          =   195
         Index           =   4
         Left            =   1260
         TabIndex        =   9
         Top             =   540
         Value           =   -1  'True
         Width           =   1035
      End
      Begin VB.OptionButton optBPS 
         Caption         =   "4&800 bps"
         Height          =   195
         Index           =   3
         Left            =   1260
         TabIndex        =   8
         Top             =   240
         Width           =   1035
      End
      Begin VB.OptionButton optBPS 
         Caption         =   "2400 &bps"
         Height          =   195
         Index           =   2
         Left            =   180
         TabIndex        =   7
         Top             =   840
         Width           =   975
      End
      Begin VB.OptionButton optBPS 
         Caption         =   "120&0 bps"
         Height          =   195
         Index           =   1
         Left            =   180
         TabIndex        =   6
         Top             =   540
         Width           =   1095
      End
      Begin VB.OptionButton optBPS 
         Caption         =   "&600 bps"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   5
         Top             =   240
         Width           =   1095
      End
   End
   Begin VB.Frame fraPort 
      Caption         =   "&Port"
      Height          =   735
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2415
      Begin VB.ComboBox cboPorts 
         Height          =   315
         Left            =   90
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   240
         Width           =   2235
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   1380
      TabIndex        =   3
      Top             =   2940
      Width           =   1000
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   2940
      Width           =   1000
   End
End
Attribute VB_Name = "frmSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public result As Long

Private Declare Function QueryDosDevice Lib "kernel32" Alias "QueryDosDeviceA" (ByVal lpDeviceName As String, ByVal lpTargetPath As String, ByVal ucchMax As Long) As Long

Private Const MAX_PATH As Long = 260
Private Sub cmdCancel_Click()

Call Me.Hide

End Sub

Private Sub cmdOK_Click()

Dim l As Long

g_ComPortNumber = Val(Mid$(cboPorts.List(cboPorts.ListIndex), 4))

For l = 0 To 4
  If optBPS(l).Value = True Then
    g_BPS = 600 * (2 ^ l)
    Exit For
  End If
Next l

For l = 0 To 1
  If optDevice(l).Value = True Then
    g_DeviceIdx = l
    Exit For
  End If
Next l


result = vbOK

Call Me.Hide

End Sub


Private Sub Form_Load()

Dim n As Long, l As Long, i As Long, sKernelName As String, sComName As String

result = vbCancel

Call CenterForm(Me, frmMain)

For i = 1 To 256
  sComName = "COM" & Format$(i)
  sKernelName = Space$(MAX_PATH * 2)
  n = QueryDosDevice(sComName, sKernelName, MAX_PATH * 2)
  If n > 0 Then
    sKernelName = Mid$(sKernelName, 9, n - 9 - 1)
    sKernelName = Replace(sKernelName, "cdcacm_Acm", "")
    Call cboPorts.AddItem(sComName & " (" & sKernelName & ")")
    If i = g_ComPortNumber Then
      cboPorts.ListIndex = cboPorts.ListCount - 1 'select the last items which we just added
    End If
  End If
Next


Select Case g_BPS
Case 600
  optBPS(0).Value = True
Case 1200
  optBPS(1).Value = True
Case 2400
  optBPS(2).Value = True
Case 4800
  optBPS(3).Value = True
Case 9600
  optBPS(4).Value = True
End Select

For l = 0 To 1
  If l = g_DeviceIdx Then
    optDevice(l).Value = True
  End If
Next l

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

Call Me.Hide

If UnloadMode <> vbFormCode Then
  Cancel = 1
End If

End Sub


